
{---------------------------------------------------------------------------}
{ BitMachine Program:  ALARM1.PAS                                             }
{ PROGRAMMER:   Terry King                                                  }
{ WHAT IT DOES: Looks for Radio Shack sensors                               }
{ HISTORY:                                                                  }
{ 04/28/97 - 1.00                                                           }
{                                                                           }
{                                                                           }
{---------------------------------------------------------------------------}

USES Crt, ParPort, Hexbin, Sounds;

CONST
Version     = '1.000 [04/28/97:  ] (c) tking@together.net '; {++Program version}
CopyRight   = 'Copyright (c) 1996, 1997 By Terry King. tking@together.net ' +
              'Box 633 Shelburne, Vermont 05482';


PF_       = 59;  {Start of FKEYBIT Special Key Values}
PF_ALT    = 104;
PF_CTRL   = 94;
PF_SHIFT  = 84;
{---------------------------------------------------------------------------}
{               V A R I A B L E S: FOR YOUR MACHINE DESIGN                  }
{                                                                           }
{ NOTE: Here, you have to tell what variables you will use to hold          }
{       temporary values for things. You can add lots more of these here.   }
{---------------------------------------------------------------------------}
VAR {MainLine}
    ch         : char;
    Bitval     : Word;
    Mask       : Word;
    BitsLastOn : Word;
    tbuff      : string;     { Strings are groups of characters        }
    BitStr,
    n          : integer;    { Integers are whole numbers up to 32,767 }
    XNow, YNow : Byte;       {Save XY Screen Position}
    Done       : Boolean;
    FunKey     : Boolean;
    Bit        : Boolean;
    UpdateScreen : boolean;
    ShowPin      : boolean;

{**********( PROCEDURES TO BE USED IN MAIN PROGRAM  )*********************}

PROCEDURE WriteBlob(X         : byte;
                    Y         : Byte;
                    Bit       : Boolean;
                    TopTitle  : string;
                    BotTitle  : String);

VAR

Column    : word;
Row       : word;

BEGIN

  FOR Row := 0 to 4 DO
    BEGIN
      GoToXY(X,Y + Row);
      FOR Column := 1 to 8 DO
        BEGIN
          IF Bit
          THEN
            BEGIN
              TextColor(LightRed);
              Write('')
            END
          ELSE
            BEGIN
             TextColor(DarkGray);
             Write('');
            END;
        TextColor(Yellow);
        END;
    END;{Blob}

  {----( Write the top and bottom titles with the correct background color )--}
  IF Bit THEN TextBackGround(LightRed)
         ELSE TextBackGround(DarkGray);
  GoToXY(X,Y);
  Write(TopTitle);
  GoToXY(X,Y+4);
  Write(BotTitle);
  TextBackground(BLUE);

END;

(*Ŀ
   MAIN PROGRAM:                                                           
  *)
BEGIN
  Writeln(CopyRight);
  Done         := FALSE;
  UpdateScreen := TRUE;
  ShowPin      := FALSE;
  BitsLastOn   := 0;
  DioReset;             {Clear output bits}

{---------( START OF PROGRAM )------------------------------------}
  TextBackground(BLUE);
  TextColor(YELLOW);
  ClrScr;

  {--- MAIN PROGRAM LOOP ---}
 REPEAT
  CheckSensors;
  IF KeyPressed THEN Done := TRUE;
  IF (BitsLastOn <> SenseBitsNow) THEN UpdateScreen := TRUE;
  BitsLastOn := SenseBitsNow;
  IF ((SenseBitsNow AND $0002) = 0) THEN AttnTone;
  IF ((SenseBitsNow AND $0004) = 0) THEN PassTone;


  IF UpdateScreen THEN
    BEGIN
      GoToXY(2,24);
      Write('ALARM1  V:' + Version + '   Port Address = X', PortAddrString);
      GoToXY(1,1);
      Writeln('ALARM1 looks for input bits from alarms');
      writeln;
      XNow := WhereX;
      YNow := WhereY;
      writeln('                BIT NUMBERS');
      writeln('                 76543210');
      writeln('                 --------');
      writeln('OUTPUT BITS NOW: ', Byte2Bin(BitsNowOn));
      writeln('INPUT  BITS NOW: ', Byte2Bin(SenseBitsNow));

    Delay(1000);
    UpdateScreen := FALSE;
  END;{UpdateScreen
{-----------------------( handle Key pressed )----------------------}
   Delay(100);
 UNTIL Done;


(*  WriteDO($FF);  {Inactive}*)



  {---------( END OF  PROGRAM )------------------------------------}

  Textmode(Co80);                        {Put the Display back to normal }

END.

