
/*---------------( ParPortIn   Function )------------------------------------*/
/* Reads both 'Printer Status' and 'Printer Control' (readback) bytes and    */
/* assembles a single 8-bit input byte with inversions fixed etc.            */
/* (c) 1998 Montain ClockWorks / Terry King (noncommercial use permitted)    */
/*---------------------------------------------------------------------------*/

unsigned char ParPortIn()
{

unsigned char StatPort;
unsigned char CtrlPort;
unsigned char PortWork;

 outp(PrtCtrlAddr, 0x04);        /* Set output port to prepare for input     */
                                 /* (Bit Position)     7 6 5 4   3 2 1 0     */
 StatPort = inp(PrtStatAddr)   ; /* (Bit Locations)    1 0 2 3   5           */
 CtrlPort = inp(PrtCtrlAddr)   ; /* (Bit Locations)              7 6 4       */
 PortWork = 0;
 PortWork = StatPort >> 6 ;                             /*Get Bit 0 and 1*/
 PortWork = PortWork | ((StatPort & 0x20) >> 3) ;       /*Get Bit 2*/
 PortWork = PortWork | ((StatPort & 0x10) >> 1) ;       /*Get Bit 3*/
 PortWork = PortWork | ((CtrlPort & 0x02) << 3) ;       /*Get Bit 4*/
 PortWork = PortWork | ((StatPort & 0x08) << 2) ;       /*Get Bit 5*/
 PortWork = PortWork | ((CtrlPort & 0x0C) << 4) ;       /*Get Bit 6 & 7*/
 PortWork = PortWork ^ DIINVERT;                        /*Fix Inverted Bits*/
 return(PortWork);

} // END ParPortIn


